Index: /anuga_work/production/wa/mandurah_2009/export_results_max.py
===================================================================
--- /anuga_work/production/wa/mandurah_2009/export_results_max.py	(revision 7688)
+++ /anuga_work/production/wa/mandurah_2009/export_results_max.py	(revision 7689)
@@ -32,6 +32,6 @@
 cellsize = 1
 
-#timestep = None    # None means no timestep!
-timestep = 0
+timestep = None    # None means no timestep!
+#timestep = 0
 
 ######
@@ -39,5 +39,5 @@
 ######
 
-area = ['Region', 'AoiR', 'Aoi1', 'Aoi2', 'Aoi3']  # strings must match keys in var_equations below
+area = ['AoiR']  # strings must match keys in var_equations below
 #area = ['All']      # 'All' means no special areas - the whole thing
 
@@ -53,5 +53,5 @@
 
 # one or more key strings from var_equations above
-var = ['elevation', 'stage']
+var = ['depth']
 
 ######
Index: /anuga_work/production/wa/mandurah_2009/get_runup.py
===================================================================
--- /anuga_work/production/wa/mandurah_2009/get_runup.py	(revision 7688)
+++ /anuga_work/production/wa/mandurah_2009/get_runup.py	(revision 7689)
@@ -17,23 +17,29 @@
 directory = project.output_folder
 
-time_dir1 = '20090324_134328_run_final_0.6_27255_Bt_kvanputt'
-time_dir2 = '20090324_140747_run_final_0.6_68693_Bt_kvanputt'
-time_dir3 = '20090327_152717_run_final_0.6_27283_Bt_kvanputt'
-time_dir4 = '20090327_160646_run_final_0_27255_Bt_kvanputt'
-time_dir5 = '20090327_161520_run_final_0_68693_Bt_kvanputt'
-time_dir6 = '20090330_120458_run_final_0_27283_Bt_kvanputt'
+time_dir1 = '20100122_164958_run_final_0.0_27255_mosuchow'
+time_dir2 = '20100122_165026_run_final_0.6_27255_mosuchow'
+time_dir3 = '20100122_165106_run_final_0.0_27283_mosuchow'
+time_dir4 = '20100122_165125_run_final_0.6_27283_mosuchow'
+time_dir5 = '20100122_165210_run_final_0.0_68693_mosuchow'
+time_dir6 = '20100122_165236_run_final_0.6_68693_mosuchow'
+time_dir7 = '20100122_165331_run_final_0.0_68486_mosuchow'
+time_dir8 = '20100122_165725_run_final_0.6_68486_mosuchow'
 
-time_dirs = [time_dir6] #3, time_dir4, time_dir5]
+time_dirs = [time_dir8] #3, time_dir4, time_dir5]
 
 interior_region = []
-for region in project.interior_regions_data[:2]:
+for region in project.interior_regions_data[2:6]:
     polygon = read_polygon(join(project.polygons_folder,
                                 region[0]))
     interior_region.append(polygon)
+    print region
 
-area_dictionary = {'Busselton': interior_region[0],
-                    'Bunbury' : interior_region[1]}
-
-area = ['Busselton', 'Bunbury'] 
+area_dictionary = {'Aoi3': interior_region[0],
+                    'Aoi4' : interior_region[1],
+                    'Area2' : interior_region[2],
+                    'Area3' : interior_region[3]}
+                   
+                   
+area = ['Aoi3', 'Aoi4', 'Area2', 'Area3'] 
 
 for time_dir in time_dirs:
Index: /anuga_work/production/wa/mandurah_2009/get_timeseries.py
===================================================================
--- /anuga_work/production/wa/mandurah_2009/get_timeseries.py	(revision 7688)
+++ /anuga_work/production/wa/mandurah_2009/get_timeseries.py	(revision 7689)
@@ -19,7 +19,11 @@
 directory = project.output_folder
 
-time_dir1 = '20090324_134328_run_final_0.6_27255_Bt_kvanputt'
 
-time_dirs = [time_dir1] #1, time_dir2, time_dir3, time_dir4, time_dir5, time_dir6]
+time_dir1 = '20100122_165026_run_final_0.6_27255_mosuchow'
+time_dir2 = '20100122_165125_run_final_0.6_27283_mosuchow'
+time_dir3 = '20100122_165236_run_final_0.6_68693_mosuchow'
+time_dir4 = '20100122_165725_run_final_0.6_68486_mosuchow'
+
+time_dirs = [time_dir4] #1, time_dir2, time_dir3, time_dir4, time_dir5, time_dir6]
 
 print 'time directories', time_dirs
@@ -27,5 +31,5 @@
 for time_dir in time_dirs:
     name = join(directory,time_dir,project.scenario_name)
-    gauge = project.gauges
+    gauge = project.gauges_folder + sep + project.gauges_filename 
     sww2csv_gauges(name+'.sww',gauge,
                    quantities = ['stage','speed','depth','elevation'],
Index: /anuga_work/production/wa/mandurah_2009/project.py
===================================================================
--- /anuga_work/production/wa/mandurah_2009/project.py	(revision 7688)
+++ /anuga_work/production/wa/mandurah_2009/project.py	(revision 7689)
@@ -122,5 +122,5 @@
 # Used in get_timeseries.py.  
 # Format easting,northing,name,elevation (with header)
-# gauges_filename = 'MH_gauges2.csv'
+gauges_filename = 'gauges.csv'
 
 # BUILDINGS EXPOSURE - for identifying inundated houses
@@ -165,8 +165,8 @@
 
 # ASCII export grid for mandurah for inundation maps
-xminRegion = 369013
-xmaxRegion = 385914
-yminRegion = 6390118
-ymaxRegion = 6415260
+#xminRegion = 369013
+#xmaxRegion = 385914
+#yminRegion = 6390118
+#ymaxRegion = 6415260
 
 xminAoiR = 370407
@@ -175,18 +175,18 @@
 ymaxAoiR = 6405626
 
-xminAoi1 = 380524
-xmaxAoi1 = 382123
-yminAoi1 = 6401707
-ymaxAoi1 = 6405240
-
-xminAoi2 = 377764
-xmaxAoi2 = 381493
-yminAoi2 = 6396471
-ymaxAoi2 = 6401692
-
-xminAoi3 = 371074
-xmaxAoi3 = 374219
-yminAoi3 = 6390639
-ymaxAoi3 = 6394731
+#xminAoi1 = 380524
+#xmaxAoi1 = 382123
+#yminAoi1 = 6401707
+#ymaxAoi1 = 6405240
+
+#xminAoi2 = 377764
+#xmaxAoi2 = 381493
+#yminAoi2 = 6396471
+#ymaxAoi2 = 6401692
+
+#xminAoi3 = 371074
+#xmaxAoi3 = 374219
+#yminAoi3 = 6390639
+#ymaxAoi3 = 6394731
 
 